<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0 - Admin Listing
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("../include/config.inc.php");
  include("../include/functions.inc.php");
  include("../include/login.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  ################################### Ende Script Einstellungen #####################
  
  $_REQUEST['next'] = $_REQUEST['next'] or $_REQUEST['next'] = 1;
  
  //Template Laden
  $template = join("", file("../templates/admin/archive.html"));
  ob_start();
  
  if($print_header)
    {
      include("../templates/admin/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("../templates/admin/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  class galerie
    {
      var $data_arr = array();
      var $img_sum;
      
      function get_data()
        {
          //Lese Bilder aus DB ein
          global $cfg;
          
          $next = empty($_REQUEST['next']) ? 0 : $_REQUEST['next'] - 1;
          $limit = $cfg->thumbs_columns * $cfg->thumbs_rows;
          $start = $next * $limit;
          
          $order = $cfg->tb_categories . ".id DESC";
          $limit = "$start, $limit";
          
          //get death Categories
          $sql = "SELECT " . $cfg->tb_images . ".* FROM " . $cfg->tb_images . " LEFT JOIN " . $cfg->tb_categories . "
                  ON " . $cfg->tb_categories . ".id = " . $cfg->tb_images . ".categorie
                  WHERE " . $cfg->tb_categories . ".id IS NULL
                  ORDER BY " . $order . " 
                  LIMIT " . $limit;
                  
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              while ($data = mysql_fetch_object($result))
                {
                  array_push($this->data_arr, $data);
                }
            }
            
          //Zhle Datenstze
          $sql = "SELECT COUNT(*) FROM " . $cfg->tb_images . " LEFT JOIN " . $cfg->tb_categories . "
                  ON " . $cfg->tb_categories . ".id = " . $cfg->tb_images . ".categorie
                  WHERE " . $cfg->tb_categories . ".id IS NULL";
                  
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          $this->img_sum = mysql_result($result, 0);
        }
        
      function list_galerie()
        {
          global $cfg, $template;
          
          preg_match("'<!-- ?table_col ?-->.+<!-- ?/table_col ?-->'is", $template, $preg);
          $tablecol = $preg[0];
          
          preg_match("'<!-- ?table_row ?-->.+<!-- ?/table_row ?-->'is", $template, $preg);
          $tablerow = $preg[0];
          
          $tabledata = array();
          $tableoutput = array();
          
          $this->get_data();
          
          $col = 1;
          
          for ($i = 0; $i < count($this->data_arr); $i++)
            {
              $data = $this->data_arr[$i];
              
              $tmp = $tablecol;
              $tmp = str_replace("%categorie%", $data->categorie, $tmp);
              $tmp = str_replace("%thumb%", $cfg->dir_link_photos . "/" . $data->thumb, $tmp);
              $tmp = str_replace("%title%", $data->title, $tmp);
              $tmp = str_replace("%description%", $data->description, $tmp);
              $tmp = str_replace("%id%", $data->id, $tmp);
              $tmp = str_replace("%width%", $cfg->upload_thumb_width, $tmp);
              $tmp = str_replace("%height%", $cfg->upload_thumb_height, $tmp);
              
              array_push($tabledata, $tmp);
              
              if(++$col > $cfg->csearch_cols)
                {
                  //Setze Cols zusammen
                  $tabledata = join("", $tabledata);
                  array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));
                  $tabledata = array();
                  $col = 1;
                }
            }
            
          //Setze restliche Cols zusammen
          $tabledata = join("", $tabledata);
          array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));  
            
          //Rows in TPL einfgen
          $tableoutput = join("", $tableoutput);
          $template = str_replace($tablerow, $tableoutput, $template);
        }  
    }
    
  $galerie = new galerie;
  $listing = $galerie->list_galerie();
  
  #################################### Template Ausgabe ##############################
  
  $start_categorie = empty($_REQUEST['categorie']) ? 0 : $_REQUEST['categorie'];

  $categories = print_categories(read_categories($start_categorie), 0);
  $template = str_replace("%categories%", $categories, $template);
  
  $template = str_replace("%categorie%", $_REQUEST['categorie'], $template);
  $template = str_replace("%next%", $_REQUEST['next'], $template);
  
  $template = str_replace("%categorie_path%", categorie_path($start_categorie), $template);
  
  if($galerie->img_sum > 0)
    {
      $template = preg_replace("'<!-- ?empty_galerie ?-->.+<!-- ?/empty_galerie ?-->'isU", "", $template);
    }
  else
    {
      $template = preg_replace("'<!-- ?full_galerie ?-->.+<!-- ?/full_galerie ?-->'isU", "", $template);
    }  
    
  //Jumpmenue
  $jumpmenue = get_jumpmenue($_REQUEST['next'], $cfg->thumbs_columns * $cfg->thumbs_rows, 10, $galerie->img_sum);
  $template = str_replace("%jumpmenue%", $jumpmenue, $template);  
  
  include("../output.inc.php");
  
?>