<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0 - Admin
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("../include/config.inc.php");
  include("../include/functions.inc.php");
  include("../include/login.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  ################################## Ende Script Einstellungen #######################
  
  $msg = null;
  
  //Template Laden
  $template = join("", file("../templates/admin/edit.html"));
  ob_start();
  
  if($print_header)
    {
      include("../templates/admin/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("../templates/admin/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  class upload
    {
      var $error;
      var $r;
      var $f;
      
      function make_image($imgname, $imgsrc, $width, $height, $size)
        {
          //Erzeuge Bild
          $img = imagecreatetruecolor($width, $height);
          
          switch($size[2])
            {
              case 1:
                $img2 = imagecreatefromgif($imgsrc);
                break;
                
              case 2:
                $img2 = imagecreatefromjpeg($imgsrc);
                break;
                
              case 3:
                $img2 = imagecreatefrompng($imgsrc);
                break;
            }
            
          imagecopyresampled($img, $img2, 0, 0, 0, 0, $width, $height, $size[0], $size[1]);
          
          switch($size[2])
            {
              case 1:
                imagegif($img, $imgname);
                break;
                
              case 2:
                imagejpeg($img, $imgname, 100);
                break;
                
              case 3:
                imagepng($img, $imgname);
                break;
            }
            
          imagedestroy($img);
          imagedestroy($img2);  
        } 
      
      function save_image()
        {
          //Bild wird auf Server gespechert
          global $cfg;
          
          if(is_uploaded_file($_FILES['upload']['tmp_name']))
            {
              $size = getimagesize($_FILES['upload']['tmp_name']);
              
              if($size[2] <= 3)
                {
                  $ext = array(1 => ".gif", 2 => ".jpg", 3 => ".png");
                  $imgname = md5(uniqid(time()));
                  $imgname = $imgname . $ext[$size[2]];
                  
                  //Speichere Thumb
                  list($width, $height) = $this->image_scall($size[0], $size[1], $cfg->upload_thumb_width, $cfg->upload_thumb_height);
                  $this->make_image($cfg->dir_path_photos . "/thumbs" . $imgname, $_FILES['upload']['tmp_name'], $width, $height, $size);
                  
                  //Speichere Bild
                  list($width, $height) = $this->image_scall($size[0], $size[1], $cfg->upload_maximg_width, $cfg->upload_maximg_height);
                  $this->make_image($cfg->dir_path_photos . "/photos/" . $imgname, $_FILES['upload']['tmp_name'], $width, $height, $size);
                  
                  return array("photos/" . $imgname, "thumbs/" . $imgname);
                }
              else
                {
                  //Unbekanntes Grafikformat
                  $this->error = 1;
                  $this->f['upload'] = $cfg->upload_incorrect_filetype;
                }  
            }
          else
            {  
              trigger_error("No Uploaded File");  
            }
        }
        
      function image_scall($width, $height, $scallwidth, $scallheight)
        {
          //Funktion berechnet Bildskalierung
          //Erwartet Bildbreite, Bildhhe, Skallierbreite, Skallierhhe
          #echo "$width, $height, $scallwidth, $scallheight +++ ";
        
          if ($width > $scallwidth || $height > $scallheight)
            {
              if ($width - $scallwidth > $height - $scallheight)
                {
                  //In der Breite skalieren
                  $div = $scallwidth / $width;
                  $height = round($height * $div);
                  $width = $scallwidth;
                }
              else  
                {
                  //In der Hhe skalieren
                  $div = $scallheight / $height;
                  $width = round($width * $div);
                  $height = $scallheight;
                }  
            }
            
          #echo " +++ $width, $height #### ";
          
          return array($width, $height);   
        } 
         
      function save_data()
        {
          global $cfg, $msg;
          
          //Pos bei neuer Kategorie
          $sql = "SELECT categorie, pos FROM " . $cfg->tb_images . " WHERE id = " . $_REQUEST['id'] . " LIMIT 1";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              $data = mysql_fetch_object($result);
              if($data->categorie != $_REQUEST['categorie'])
                {
                  //Neue Pos
                  $sql = "SELECT COUNT(*) FROM " . $cfg->tb_images . " WHERE categorie = " . $_REQUEST['categorie'];
                  $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
                  if($result)
                    {
                      $data = mysql_fetch_assoc($result);
                      $pos = $data['COUNT(*)'];
                      $pos++;
                      
                      $pos_str = "pos = $pos,";
                    }
                }
            }
          
          $sql = "UPDATE " . $cfg->tb_images . " SET
                  title = '" . $this->r['title'] . "',
                  description = '" . $this->r['description'] . "',
                  categorie = '" . $this->r['categorie'] . "',
                  slideshow = '" . $this->r['slideshow'] . "',
                  $pos_str
                  startpage = '" . $this->r['startpage'] . "'
                  WHERE id = " . $_REQUEST['id'];
                  
                  #thumb = '" . $this->r['thumb'] . "',
                  #upload_date = NOW(),
                  #status = 1";
                  
          #echo $sql;
          mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          
          header("Refresh: 0; URL=\"list.php?categorie=" . $_REQUEST['categorie'] . "&next=" . $_REQUEST['next'] . "\"");
          exit;
        }
      
      function create_image()
        {
          //Lade Bild hoch
          global $cfg, $msg;
          
          if($this->check_data())
            {
              if($this->error != 1)
                {
                  $this->save_data();  
                }
              else
                {
                  $msg->main_msg = $cfg->upload_incorrect_input;
                }
            }
          else
            {
              //Fehler beim eingeben der Daten
              $msg->main_msg = $cfg->upload_incorrect_input;
            }  
        }
        
      function check_data()
        {
          global $cfg;
          
          //Title
          if($cfg->upload_input_title == 1 && empty($_REQUEST['title']))
            {
              $this->error = 1;
              $this->f['title'] = $cfg->upload_no_title;
            }
            
          //Beschreibung
          if($cfg->upload_input_description == 1 && empty($_REQUEST['description']))
            {
              $this->error = 1;
              $this->f['description'] = $cfg->upload_no_description;
            }
            
          //Title
          if(empty($_REQUEST['categorie']))
            {
              $this->error = 1;
              $this->f['categorie'] = $cfg->upload_no_categorie;
            }
            
          $this->r['title'] = $_REQUEST['title'];
          $this->r['description'] = $_REQUEST['description'];
          $this->r['categorie'] = $_REQUEST['categorie'];
          $this->r['slideshow'] = $_REQUEST['slideshow'];
          $this->r['startpage'] = $_REQUEST['startpage'];
          
          return $this->error == 1 ? 0 : 1;
        }
          
    }
  
  if($_REQUEST['action'] == "edit")
    {
      //Bild Upload
      $upload = new upload;
      $upload->create_image();
      
    }
    
    
  //Bilddaten einlesen
  $sql = "SELECT * FROM " . $cfg->tb_images . " WHERE id = " . $_REQUEST['id'] . " LIMIT 1";
  $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
  if($result)
    {
      $r = mysql_fetch_array($result, MYSQL_ASSOC);
      $r['thumb'] = $cfg->dir_link_photos . "/" . $r['thumb'];
      $r['file'] = $cfg->dir_link_photos . "/" . $r['file'];
     }
  
  #################################### Template Ausgabe ##############################
  
  $array = array("title", "description", "categorie", "upload", "thumb", "file", "id", "slideshow", "startpage");
  
  foreach($array as $key)
    {
      $template = str_replace("%$key%", $r[$key], $template);
      $template = str_replace("%f$key%", $upload->f[$key], $template);
    }
    
  $template = str_replace("%next%", $_REQUEST['next'], $template);
    
  include("../output.inc.php");
  
?>