<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0 - Admin
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("../include/config.inc.php");
  include("../include/functions.inc.php");
  include("../include/login.inc.php");
  include("../cronjob.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  //Template Laden
  $template = join("", file("../templates/admin/index.html"));
  ob_start();
  
  if($print_header)
    {
      include("../templates/admin/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("../templates/admin/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  /*function get_space($dir) 
    { 
       $s = stat($dir); 
       $space = $s["blocks"]*512; 
       if (is_dir($dir)) 
       { 
         $dh = opendir($dir); 
         while (($file = readdir($dh)) !== false) 
           if ($file != "." and $file != "..") 
             $space += get_space($dir."/".$file); 
         closedir($dh); 
       } 
       return $space; 
    }*/  
    
  function get_space($dir) 
    { 
      if (is_dir($dir)) 
        { 
          $space = filesize($dir);
          
          $d = opendir($dir); 
          while (($file = readdir($d)) !== false)
            {
              if ($file != "." and $file != "..")
                {
                  if(is_file($dir."/".$file))
                    {
                      $space += filesize($dir."/".$file);
                    }
                  elseif(is_dir($dir."/".$file))
                    {
                      $space += get_space($dir."/".$file);
                    }  
                }
            }
              
            closedir($d); 
          } 
       return $space; 
    }  
  
  //Version Check
  $fp = fopen("../version.txt", "r");
  if($fp)
    {
      $version = fgets($fp, 1024);
      fclose($fp);
    }
    
  //Aktuelle Version vom Server holen
  
  $header = "GET /update/photo_galerie.txt HTTP/1.1\r\n";
  $header.= "Host: www-gestaltung.de\r\n";
  $header.= "Connection: close\r\n\r\n";

  $host = "www-gestaltung.de";
  $path = "/update/photo_galerie.txt";
  $fp = fsockopen($host, 80);
  if($fp)
    {
      fputs ($fp, $header);
      while(!feof($fp))
        {
          if(in_array (fgets($fp, 1024), array ("\r\n", "\n", "\r")))
            {
              break;
            }
        }
      
      $cur_version = fgets($fp, 1024);
      fclose($fp);
    }
      
  if($version && $cur_version && $cur_version > $version)
    {
      $template = str_replace("%version%", $cur_version, $template);
    }
  else
    {
      $template = preg_replace("'<!-- ?version_check ?-->.+<!-- ?/version_check ?-->'isU", "", $template);
    } 
    
  //Speicherverbrauch ermitteln
  $space_galerie = get_space($cfg->dir_path_photos . "/photos");
  $space_galerie += get_space($cfg->dir_path_photos . "/thumbs");
  $space_galerie = user_filesize($space_galerie);
  
  $space_upload_dir = get_space($cfg->dir_path_photos . "/upload");
  $space_upload_dir = user_filesize($space_upload_dir);
  
  //Zhle Bilder
  $sql = "SELECT COUNT(*) FROM " . $cfg->tb_images . " WHERE 1";
  $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
  $sum_images = mysql_result($result, 0);
  
  //Zhle Kategorien
  $sql = "SELECT COUNT(*) FROM " . $cfg->tb_categories . " WHERE 1";
  $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
  $sum_categories = mysql_result($result, 0);
  
  
  
  #################################### Template Ausgabe ##############################
  
  $template = str_replace("%space_galerie%", $space_galerie, $template);
  $template = str_replace("%space_upload_dir%", $space_upload_dir, $template);
  $template = str_replace("%sum_images%", $sum_images, $template);
  $template = str_replace("%sum_categories%", $sum_categories, $template);
  
  include("../output.inc.php");
     
?>