<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("include/config.inc.php");
  include("include/functions.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  #################################### Script Einstellungen Ende ####################
  
  //Template Laden
  $template = join("", file("templates/view.html"));
  ob_start();
  
  if($print_header)
    {
      include("templates/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("templates/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  function slide_show($cur_pos)
    {
      global $cfg, $template;
      
      preg_match("'<!-- ?slide_show ?-->.+<!-- ?/slide_show ?-->'isU", $template, $preg);
      $slide_show = $preg[0];
      
      preg_match("'<!-- ?current_image ?-->.+<!-- ?/current_image ?-->'isU", $template, $preg);
      $current_image = $preg[0];
      
      if($slide_show && $current_image)
        {
          $data_arr = array();
          
          //Lese Vorherige Bilder ein
          $sql = "SELECT * FROM " . $cfg->tb_images . " WHERE pos <= " . $cur_pos . " AND categorie = " . $_REQUEST['categorie'] . " ORDER BY pos DESC LIMIT " . $cfg->slide_show_length;
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              while($data = mysql_fetch_object($result))
                {
                  if($data->pos == $cur_pos)
                    {
                      $tmp = $current_image;
                    }
                  else
                    {
                      $tmp = $slide_show;
                    }
                    
                  $tmp = str_replace("%id%", $data->id, $tmp);
                  $tmp = str_replace("%thumb%", $cfg->dir_link_photos . "/" . $data->thumb, $tmp);
                  
                  array_unshift($data_arr, $tmp);
                }
            }
            
          //Lese Vorherige Bilder ein
          $limit = floor($cfg->slide_show_length / 2);
          $limit = count($data_arr) > $limit ? $limit : $limit + $limit + 1 - count($data_arr);
          
          $sql = "SELECT * FROM " . $cfg->tb_images . " WHERE pos > " . $cur_pos . " AND categorie = " . $_REQUEST['categorie'] . " ORDER BY pos ASC LIMIT $limit";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              while($data = mysql_fetch_object($result))
                {
                  if($data->pos == $cur_pos)
                    {
                      $tmp = $current_image;
                    }
                  else
                    {
                      $tmp = $slide_show;
                    }
                    
                  $tmp = str_replace("%id%", $data->id, $tmp);
                  $tmp = str_replace("%thumb%", $cfg->dir_link_photos . "/" . $data->thumb, $tmp);
                  
                  array_push($data_arr, $tmp);
                }
            }  
            
          //Gebe alles aus
          #echo "<pre>"; print_r($data_arr); echo "</pre>";
          
          //Array anpassen
          while(count($data_arr) > $cfg->slide_show_length)
            {
              array_shift($data_arr);
            }
          
          $data_arr = join("", $data_arr);
          $template = str_replace($slide_show, $data_arr, $template);
          $template = str_replace($current_image, "", $template);
        }
    }
  
  //Lese Bild ein
  $sql = "SELECT * FROM " . $cfg->tb_images . " WHERE id = " . $_REQUEST['id'] . " LIMIT 1";
  $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
  if($result)
    {
      $data = mysql_fetch_object($result);
      
      $data->file = $cfg->dir_link_photos . "/" . $data->file;
      $data->thumb = $cfg->dir_link_photos . "/" . $data->thumb;
    }
    
  $cur_pos = $data->pos;  
    
  //Jump Links ermitteln
  $sql = "SELECT id FROM " . $cfg->tb_images . " WHERE categorie = " . $data->categorie . " AND pos > " . $data->pos . " ORDER BY pos ASC LIMIT 1";
  $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
  if($result)
    {
      $next_link = mysql_num_rows($result) > 0 ? mysql_result($result, 0) : "";
    }
    
  $sql = "SELECT id FROM " . $cfg->tb_images . " WHERE categorie = " . $data->categorie . " AND pos < " . $data->pos . " ORDER BY pos DESC LIMIT 1";
  $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
  if($result)
    {
      $prev_link = mysql_num_rows($result) > 0 ? mysql_result($result, 0) : "";
    }  
  
  #################################### Template Ausgabe ##############################
  
  slide_show($cur_pos);
  
  $array = array("id", "title", "description", "file", "thumb", "counter", "categorie", "pos");
  
  foreach($array as $key)
    {
      $template = str_replace("%$key%", $data->{$key}, $template);
    }
    
  $template = str_replace("%next%", $next, $template);
  $template = str_replace("%categorie%", $_REQUEST['categorie'], $template);  
  $template = empty($next_link) ? preg_replace("'<!-- ?next_link ?-->.+<!-- ?/next_link ?-->'is", "", $template) : str_replace("%next_link%", "view.php?id=" . $next_link . "&categorie=" . $_REQUEST['categorie'] . "&next=" . $_REQUEST['next'], $template);
  $template = empty($prev_link) ? preg_replace("'<!-- ?prev_link ?-->.+<!-- ?/prev_link ?-->'is", "", $template) : str_replace("%prev_link%", "view.php?id=" . $prev_link . "&categorie=" . $_REQUEST['categorie'] . "&next=" . $_REQUEST['next'], $template);
  
  include("output.inc.php");
     
?>