<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.1 - Admin Kategorie Verwaltung
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("../include/config.inc.php");
  include("../include/functions.inc.php");
  include("../include/login.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  //Template Laden
  $template = join("", file("../templates/admin/categories.html"));
  ob_start();
  
  if($print_header)
    {
      include("../templates/admin/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("../templates/admin/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  class galerie
    {
      var $data_arr = array();
      
      function get_data()
        {
          //Lese Bilder aus DB ein
          global $cfg;
          
          $order = "id DESC";
          $limit = "0, 25";
          
          $sql = "SELECT * FROM " . $cfg->tb_images . " WHERE categorie = '" . $_REQUEST['categorie'] . "' AND status = 1 ORDER BY " . $order . " LIMIT " . $limit;
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              while ($data = mysql_fetch_object($result))
                {
                  array_push($this->data_arr, $data);
                }
            }
             
          return mysql_num_rows($result);
        }
        
      function list_galerie()
        {
          global $cfg, $template;
          
          preg_match("'<!-- ?table_col ?-->.+<!-- ?/table_col ?-->'is", $template, $preg);
          $tablecol = $preg[0];
          
          preg_match("'<!-- ?table_row ?-->.+<!-- ?/table_row ?-->'is", $template, $preg);
          $tablerow = $preg[0];
          
          $tabledata = array();
          $tableoutput = array();
          
          $this->get_data();
          
          for ($i = 0; $i < count($this->data_arr); $i++)
            {
              $data = $this->data_arr[$i];
              
              $tmp = $tablecol;
              $tmp = str_replace("%categorie%", $data->id, $tmp);
              $tmp = str_replace("%thumb%", "../" . $data->thumb, $tmp);
              $tmp = str_replace("%title%", $data->title, $tmp);
              $tmp = str_replace("%description%", $data->description, $tmp);
              $tmp = str_replace("%id%", $data->id, $tmp);
              $tmp = str_replace("%width%", $cfg->upload_thumb_width, $tmp);
              $tmp = str_replace("%height%", $cfg->upload_thumb_height, $tmp);
              
              array_push($tabledata, $tmp);
              
              if(++$col > $cfg->csearch_cols)
                {
                  //Setze Cols zusammen
                  $tabledata = join("", $tabledata);
                  array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));
                  $tabledata = array();
                  $col = 1;
                }
            }
            
          //Setze restliche Cols zusammen
          $tabledata = join("", $tabledata);
          array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));  
            
          //Rows in TPL einfgen
          $tableoutput = join("", $tableoutput);
          $template = str_replace($tablerow, $tableoutput, $template);
        }  
    }
    
  #################################### Action #######################################
  
  if($_POST['action'] == "rename")
    {
      if (empty ($_POST['rename']))
        {
          $msg->error = $cfg->categories_no_name;
          $error = 1;
        }
      else
        {
          //Prfe ob Kategorie bereits existiert
          $sql = "SELECT id, name FROM " . $cfg->tb_categories . " WHERE parent = '" . get_parent($_POST['categorie']) . "' AND name = '" . $_POST['rename'] . "'";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              if(mysql_num_rows($result) > 0)
                {
                  $curcat = get_categorie_name($_POST['categorie']);
                  if($curcat != $_POST['rename'] && strtolower($curcat) != strtolower($_POST['rename']))
                    {
                      $error = 1;
                      $msg->error = str_replace("%s", $_POST['rename'], $cfg->categories_categorie_exists);
                    }
                }
                
              if($error != 1)
                {
                  //Kategorie Umbenennen
                  $sql = "UPDATE " . $cfg->tb_categories . " SET name = '" . $_POST['rename'] . "' WHERE id = " . $_POST['categorie'] . " LIMIT 1";
                  mysql_query ($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
        
                  $reset_form = true;
                  $msg->main_msg = str_replace("%x", $_POST['rename'], str_replace("%s", $data->name, $cfg->categories_categorie_renamed));
                }
            }
        }
    }
  elseif($_POST['action'] == "insert")
    {
      if (empty ($_POST['insert']))
        {
          $msg->error = $cfg->categories_no_name;
          $error = 1;
        }
      else
        {
          //Prfe ob Kategorie bereits existiert
          $sql = "SELECT id, name FROM " . $cfg->tb_categories . " WHERE parent = '" . $_POST['categorie'] . "' AND name = '" . $_POST['insert'] . "'";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              if(mysql_num_rows($result) > 0)
                {
                  $error = 1;
                  $msg->error = str_replace("%s", $_POST['insert'], $cfg->categories_categorie_exists);
                }
              else
                {
                  //Kategorie anlegen
                  $categorie_name = get_categorie_name($_POST['categorie']);
                  
                  $sql = "INSERT INTO " . $cfg->tb_categories . " SET 
                          name = '" . $_POST['insert'] . "', 
                          parent = " . $_POST['categorie'] . ",
                          status = 1,
                          icon = 'icons/categorie.png'";
                          
                  mysql_query ($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
        
                  $msg->main_msg = str_replace("%s", $_POST['insert'], str_replace("%x", $categorie_name, $cfg->categories_categorie_inserted));
                }
            }
        }
    }
  elseif($_POST['action'] == "move")
    {
      //Verschiebe Kategorie
      if (empty ($_POST['move_to']))
        {
          $msg->error = $cfg->categories_no_name;
          $error = 1;
        }
      else
        {
          //Kategorie Name
          $categorie_name = get_categorie_name($_POST['categorie']);
          
          //Prfe ob Kategorie bereits existiert
          $sql = "SELECT id, name FROM " . $cfg->tb_categories . " WHERE parent = '" . $_POST['move_to'] . "' AND name = '" . $categorie_name . "'";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              if(mysql_num_rows($result) > 0)
                {
                  $error = 1;
                  $msg->error = str_replace("%s", $_POST['insert'], $cfg->categories_categorie_exists);
                }
              else
                {
                  //Kategorie verschieben
                  $categorie_move_to_name = get_categorie_name($_POST['move_to']);
                  
                  $sql = "UPDATE " . $cfg->tb_categories . " SET 
                          parent = " . $_POST['move_to'] . "
                          WHERE id = " . $_POST['categorie'];
                          
                  mysql_query ($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
        
                  $msg->main_msg = str_replace("%s", $categorie_name, str_replace("%x", $categorie_move_to_name, $cfg->categories_categorie_moved));
                }
            }
        }
    }    
  elseif($_POST['action'] == "delete")
    {
      if($_POST['categorie'] > 0)
        {
          $categorie_name = get_categorie_name($_POST['categorie']);
          $parent = get_parent($_POST['categorie']);
          
          //Lese unterkategorien ein
          $subcategories = get_subcategories($_POST['categorie']);
          
          $subcategories = join(",", $subcategories);
          
          if($_POST['delete_images'] == 1)
            {
              //Lsche Bilder aus Unterkategorien
              $sql = "DELETE FROM " . $cfg->tb_images . " WHERE categorie IN($subcategories)";
              mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
            }
            
          $sql = "DELETE FROM " . $cfg->tb_categories . " WHERE id IN($subcategories)";
          mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          
          $msg->main_msg = str_replace("%s", $categorie_name, $cfg->categories_categorie_deleted);
          
          $_REQUEST['categorie'] = $parent;
        }
      else
        {
          $msg->error = str_replace("%s", $cfg->categorie_home_name, $cfg->categories_unable_to_delete);
        }  
    }
  
  
  $galerie = new galerie;
  $listing = $galerie->list_galerie();
  
  #################################### Template Ausgabe ##############################
  
  $categorie = empty($_REQUEST['categorie']) ? 0 : $_REQUEST['categorie'];
  $categorie_name = empty($_REQUEST['categorie_name']) ? $cfg->categorie_home_name : $_REQUEST['categorie_name'];
  
  $template = str_replace("%categorie%", $categorie, $template);
  $template = str_replace("%categorie_name%", $categorie_name, $template);

//   $categories = print_categories(read_categories($start_categorie), 2);
//   $template = str_replace("%categories%", $categories, $template);
//   #$template = str_replace("%listing%", $listing, $template);
//   $template = str_replace("%categorie_path%", categorie_path($start_categorie), $template);
//   
  include("../output.inc.php");
  
  #echo "<pre>"; print_r(read_categories(35)); echo "</pre>";
  
?>