<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0 - Admin Delete Image
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("../include/config.inc.php");
  include("../include/functions.inc.php");
  include("../include/login.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  //Template Laden
  $template = join("", file("../templates/admin/delete.html"));
  ob_start();
  
  if($print_header)
    {
      include("../templates/admin/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("../templates/admin/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  if($_REQUEST['action'] == "delete" && !empty($_REQUEST['delete']) && $_REQUEST['mode'] != "folder_delete")
    {
      $delete = join(",", array_keys($_REQUEST['delete']));
        
      if(!empty($delete))
        {
          $sql = "DELETE FROM " . $cfg->tb_images . " WHERE id IN(" . $delete . ")";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
        }
      
      //Lsche Bilder
      foreach($_REQUEST['delete'] as $key => $val)
        {
          if($val == 1)
            {
              unlink($cfg->dir_path_photos . "/" . $_REQUEST['file'][$key]);
              unlink($cfg->dir_path_photos . "/" . $_REQUEST['thumb'][$key]);
            }
        }
        
      //Zurck zur bersicht
      header("Location: list.php?categorie=" . $_REQUEST['categorie'] . "&next=" . $_REQUEST['next']);
      exit;  
    }
  elseif($_REQUEST['action'] == "delete" && !empty($_REQUEST['delete']) && $_REQUEST['mode'] == "folder_delete")
    {
      $del_counter = 0;
      
      //Lsche Bilder aus Upload Ordner
      delete_img(array_keys($_REQUEST['delete']));
        
      if(!$error)
        {
          $msg = str_replace("%s", $del_counter, $cfg->folder_delete_succesfull);
          $msg = urldecode($msg);
        }
        
      header("Location: folder_upload.php?dir=" . $_REQUEST['categorie'] . "&msg=$msg");  
      exit;
    }
  elseif($_REQUEST['action'] == "delete" && $_REQUEST['mode'] == "folder_delete")
    {
      header("Location: list.php?categorie=" . $_REQUEST['categorie'] . "&next=" . $_REQUEST['next']);
      exit;
    }
  elseif($_REQUEST['action'] == "delete")
    {
      header("Location: list.php?categorie=" . $_REQUEST['categorie'] . "&next=" . $_REQUEST['next']);
      exit;
    }
  elseif($_REQUEST['mode'] == "folder_delete")
    {
      //Zu lschende Bilder einlesen
      preg_match("'<!-- ?table_row ?-->.+<!-- ?/table_row ?-->'is", $template, $preg);
      $tablerow = $preg[0];
      $tableoutput = array();
      
      if(is_array($_REQUEST['delete']))
        {
          $_REQUEST['delete'] = join(",", $_REQUEST['delete']);
        }
        
      $del_arr = explode(",", $_REQUEST['delete']);
      
      foreach($del_arr as $img_file)
        {
          //erzeuge Thumb wenn es nicht existiert
          $type = strrchr($img_file, ".");
          $tempfile = "thumb_" . md5($img_file) . $type;
          
          if(is_writable($cfg->dir_path_photos . "/tmp"))
            {
              if(is_file($cfg->dir_path_photos . "/tmp/" . $tempfile))
                {
                  $thumb = $cfg->dir_link_photos . "/tmp/" . $tempfile;
                }
              else
                {
                  $thumb = "../img.php?file=upload" . $img_file . "&width=" . $cfg->upload_thumb_width . "&height=" . $cfg->upload_thumb_height . "&save=" . $cfg->dir_path_photos . "/tmp/" . $tempfile;
                }
            }
          else
            {
              $thumb = "../img.php?file=upload" . $img_file . "&width=" . $cfg->upload_thumb_width . "&height=" . $cfg->upload_thumb_height;
            }
          
          
          $tmp = $tablerow;
          $tmp = str_replace("%id%", $img_file, $tmp);
          $tmp = str_replace("%thumb%", $thumb, $tmp);
          $tmp = str_replace("%file%", $cfg->dir_link_photos . "/upload/" . $img_file, $tmp);
          $tmp = str_replace("%title%", "", $tmp);
          $tmp = str_replace("%description%", "", $tmp);
          
          array_push($tableoutput, $tmp);
        }
        
      $tableoutput = join("", $tableoutput);  
      $template = str_replace($tablerow, $tableoutput, $template);
    }    
  else
    {
      //Zu lschende Bilder einlesen
      preg_match("'<!-- ?table_row ?-->.+<!-- ?/table_row ?-->'is", $template, $preg);
      $tablerow = $preg[0];
      $tableoutput = array();
      
      if(is_array($_REQUEST['delete']))
        {
          $_REQUEST['delete'] = join(",", $_REQUEST['delete']);
        }
        
      if($_REQUEST['delete'])
        {
          $sql = "SELECT * FROM " . $cfg->tb_images . " WHERE id IN(" . $_REQUEST['delete'] . ")";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
        }
        
      if($result)
        {
          while($data = mysql_fetch_object($result))
            {
              $tmp = $tablerow;
              $tmp = str_replace("%id%", $data->id, $tmp);
              $tmp = str_replace("%thumb%", $cfg->dir_link_photos . "/" . $data->thumb, $tmp);
              $tmp = str_replace("%thumb_file%", $data->thumb, $tmp);
              $tmp = str_replace("%image_file%", $data->file, $tmp);
              $tmp = str_replace("%title%", $data->title, $tmp);
              $tmp = str_replace("%description%", $data->description, $tmp);
              
              array_push($tableoutput, $tmp);
            }
        }  
        
      $tableoutput = join("", $tableoutput);  
      $template = str_replace($tablerow, $tableoutput, $template);
    }  
  
  #################################### Template Ausgabe ##############################
  
  $template = str_replace("%next%", $_REQUEST['next'], $template);
  $template = str_replace("%categorie%", $_REQUEST['categorie'], $template);
  $template = str_replace("%mode%", $_REQUEST['mode'], $template);
  
  include("../output.inc.php");
     
?>