<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0 - Admin Listing
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("../include/config.inc.php");
  include("../include/functions.inc.php");
  include("../include/login.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  $cfg->folder_upload_folder_cols = 4;
  $cfg->folder_upload_file_cols = 4;
  
  $cfg->folder_upload_images_limit = 50;
  
  ################################### Ende Script Einstellungen #####################
  
  $_REQUEST['next'] = $_REQUEST['next'] or $_REQUEST['next'] = 1;
  
  //Template Laden
  $template = "../templates/admin/folder_upload.html";
  ob_start();
  
  if($print_header)
    {
      include("../templates/admin/header.html");
    }
    
  include($template);
  
  if($print_footer)
    {
      include("../templates/admin/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  class galerie
    {
      var $filepath;
      var $dir_arr;
      var $file_arr;
      var $img_sum;
      
      function get_data()
        {
          //Lese Bilder aus Upload Ordner ein
          global $cfg;
          
//           $next = empty($_REQUEST['next']) ? 0 : $_REQUEST['next'] - 1;
//           $limit = $cfg->thumbs_columns * $cfg->thumbs_rows;
//           $start = $next * $limit;
          
          $dir = $_REQUEST['dir'] == "" ? "" : $_REQUEST['dir'];
          
          if(is_readable($cfg->dir_path_photos . "/upload" . $dir))
            {
              $this->read_folder($dir);
              $this->print_data();
            }
          else
            {
              die("Unable to open Dir upload$dir");
            }  
        } 
         
      function read_folder($dir = "")
        {
          global $cfg;
          
          $dir_arr = array();
          $file_arr = array();
          $this->filepath = $dir;
          
          
          //Lese Daten aus Ornder ein
          $d = dir($cfg->dir_path_photos . "/upload" . $dir);
          
          while(($entry = $d->read()) !== false)
            {
              if(is_dir($d->path . "/" . $entry))
                {
                  if($entry != "." AND $entry != "..")
                    {
                      array_push($dir_arr, array("name" => $entry, "dir" => $dir));
                    }
                }
              elseif(is_file($d->path . "/" . $entry))
                {
                  $type = strtolower(strrchr($entry, "."));
                  if(in_array($type, array(".gif", ".jpg", ".jpe", ".jgeg", ".png")) && substr($entry, 0, 6) != "thumb_")
                    {
                      array_push($file_arr, array("name" => $entry, "type" => $type, "dir" => $dir));
                      $this->img_sum++;
                    }
                }
              else
                {
                  #echo $d->path . "/$entry<br />";
                }  
            }
            
          $d->close();
           
          //Sortiere Arrays
          arr_sort($dir_arr, array("+name"));
          arr_sort($file_arr, array("+name"));
          
          //Index neu vergeben
          array_key_reset($file_arr);
          array_key_reset($dir_arr);
           
          $this->file_arr = $file_arr;
          $this->dir_arr = $dir_arr;
        }
           
      function print_data()
        {
          global $cfg, $template;
          
          preg_match("'<!-- ?table_col_folder ?-->.+<!-- ?/table_col_folder ?-->'is", $template, $preg);
          $tablecol = $preg[0];
          
          preg_match("'<!-- ?table_row_folder ?-->.+<!-- ?/table_row_folder ?-->'is", $template, $preg);
          $tablerow = $preg[0];
          
          $tabledata = array();
          $tableoutput = array();
          
          $col = 1;
          
          for ($i = 0; $i < count($this->dir_arr); $i++)
            {
              $data = $this->dir_arr[$i];
              
              $tmp = $tablecol;
              $tmp = str_replace("%name%", $data['name'], $tmp);
              $tmp = str_replace("%id%", urlencode($data['name']), $tmp);
              $tmp = str_replace("%dir%", $data['dir'] . "/" . $data['name'], $tmp);
              
              array_push($tabledata, $tmp);
              
              if(++$col > $cfg->folder_upload_folder_cols)
                {
                  //Setze Cols zusammen
                  $tabledata = join("", $tabledata);
                  array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));
                  $tabledata = array();
                  $col = 1;
                }
            }
            
          //Setze restliche Cols zusammen
          $tabledata = join("", $tabledata);
          array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));  
            
          //Rows in TPL einfgen
          $tableoutput = join("", $tableoutput);
          $template = str_replace($tablerow, $tableoutput, $template);
            
          //Bilder
          
          preg_match("'<!-- ?table_col ?-->.+<!-- ?/table_col ?-->'is", $template, $preg);
          $tablecol = $preg[0];
          
          preg_match("'<!-- ?table_row ?-->.+<!-- ?/table_row ?-->'is", $template, $preg);
          $tablerow = $preg[0];
          
          $tabledata = array();
          $tableoutput = array();
          
          $col = 1;
          
          $start = empty($_REQUEST['next']) ? 0 : $_REQUEST['next'] - 1;
          $start = $cfg->folder_upload_images_limit * $start;
          $stop = $start + $cfg->folder_upload_images_limit;
          
          for ($i = $start; $i < $stop; $i++)
            {
              if($data = $this->file_arr[$i])
                {
                  
                  $img_file = $cfg->dir_path_photos . "/upload" . $data['dir'] . $data['name'];
                  
                  $tempfile = "thumb_" . md5($data['dir'] . "/" . $data['name']) . $data['type'];
                  
                  //erzeuge Thumb wenn es nicht existiert
                  if(is_writable($cfg->dir_path_photos . "/tmp"))
                    {
                      if(is_file($cfg->dir_path_photos . "/tmp/" . $tempfile))
                        {
                          $thumb = $cfg->dir_link_photos . "/tmp/" . $tempfile;
                        }
                      else
                        {
                          $thumb = "../img.php?file=" . $cfg->dir_path_photos . "/upload/" . $data['dir'] . "/" . $data['name'] . "&width=" . $cfg->upload_thumb_width . "&height=" . $cfg->upload_thumb_height . "&save=" . $cfg->dir_path_photos . "/tmp/" . $tempfile;
                        }
                    }
                  else
                    {
                      $thumb = "../img.php?file=" . $cfg->dir_path_photos . "/upload/" . $data['dir'] . "/" . $data['name'] . "&width=" . $cfg->upload_thumb_width . "&height=" . $cfg->upload_thumb_height;
                    }  
                  
                  $tmp = $tablecol;
                  $tmp = str_replace("%thumb%", $thumb, $tmp);
                  $tmp = str_replace("%id%", $data['dir'] . "/" . $data['name'], $tmp);
                  $tmp = str_replace("%name%", $data['name'], $tmp);
                  
                  if(!is_writeable($img_file) || empty($cfg->ftp_user))
                    {
                      $tmp = preg_replace("'<!-- ?link_delete ?-->.+<!-- ?/link_delete ?-->'isU", "", $tmp);
                    }
                    
                  
                  array_push($tabledata, $tmp);
                  
                  if(++$col > $cfg->folder_upload_file_cols)
                    {
                      //Setze Cols zusammen
                      $tabledata = join("", $tabledata);
                      array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));
                      $tabledata = array();
                      $col = 1;
                    }
                }
            }
            
          //Setze restliche Cols zusammen
          $tabledata = join("", $tabledata);
          array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));  
            
          //Rows in TPL einfgen
          $tableoutput = join("", $tableoutput);
          $template = str_replace($tablerow, $tableoutput, $template);  
            
            
        }
      function delete_dir()
        {
          for ($i = 0; $i < count($this->dir_arr); $i++)
            {
              $option .= '<option value="' . $this->dir_arr[$i]['dir'] . '/' . $this->dir_arr[$i]['name'] . '">' . $this->dir_arr[$i]['name'] . '</option>';
            }
            
          return $option;
        }
    }
    
  if($_POST['action'] == "move")
    {
      //Verschiebe Bilder in Kategorie
      $move_counter = 0;
      $del_arr = array();
      
      foreach($_POST['image'] as $key => $val)
        {
          if(is_file($cfg->dir_path_photos . "/upload/" . $val))
            {
              array_push($del_arr, $val);
              
              $size = getimagesize($cfg->dir_path_photos . "/upload/" . $val);
              
              $ext = array(1 => ".gif", 2 => ".jpg", 3 => ".png");
              $imgname = md5(uniqid(time()));
              $imgname = $imgname . $ext[$size[2]];
              
              list($width, $height) = image_scall($size[0], $size[1], $cfg->upload_thumb_width, $cfg->upload_thumb_height);
              make_image($cfg->dir_path_photos . "/thumbs/" . $imgname, $cfg->dir_path_photos . "/upload/" . $val, $width, $height, $size);
                  
              list($width, $height) = image_scall($size[0], $size[1], $cfg->upload_maximg_width, $cfg->upload_maximg_height);
              make_image($cfg->dir_path_photos . "/photos/" . $imgname, $cfg->dir_path_photos . "/upload/" . $val, $width, $height, $size);
              
              //Position
              $pos = 1;
              
              //Verschiebe andere Elemente
              $sql = "UPDATE " . $cfg->tb_images . " SET pos = pos + 1 WHERE categorie = " . $_REQUEST['move_to'];
              mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
              
              //Speichere Bild in DB
              $sql = "INSERT INTO " . $cfg->tb_images . " SET
                      categorie = '" . $_POST['move_to'] . "',
                      file = 'photos/" . $imgname . "',
                      thumb = 'thumbs/" . $imgname . "',
                      upload_date = NOW(),
                      pos = $pos,
                      status = 1";
                      
              mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
              
              $move_counter++;
            }
        }    
        
      //Lsche altes Bild
      delete_img($del_arr);
      $tmp_msg = str_replace("%s", $move_counter, $cfg->folder_upload_images_moved);
      $tmp_msg = str_replace("%x", categorie_path($_REQUEST['move_to'], 1), $tmp_msg);
      $msg->main_msg = $tmp_msg;
    }
  elseif($_POST['action'] == "delete_dir")
    {
      //Lsche Ordner
      if(delete_dir($_POST['dir_name']) > 0)
        {
          $msg->main_msg = $cfg->folder_upload_dir_deleted;
        }  
    }
    
    
  $galerie = new galerie;
  $listing = $galerie->get_data();
  $delete_dir = $galerie->delete_dir();
  
  #################################### Template Ausgabe ##############################
  
  $start_categorie = empty($_REQUEST['categorie']) ? 0 : $_REQUEST['categorie'];

  $categories = print_categories(read_categories($start_categorie), 0);
  $template = str_replace("%categories%", $categories, $template);
  
  $template = str_replace("%categorie%", $_REQUEST['categorie'], $template);
  $template = str_replace("%next%", $_REQUEST['next'], $template);
  
  $template = str_replace("%parent_dir%", substr($galerie->filepath, 0, strrpos($galerie->filepath, "/")), $template);
  $template = str_replace("%filepath%", $galerie->filepath, $template);
  
  if($galerie->img_sum > 0)
    {
      $template = preg_replace("'<!-- ?empty_galerie ?-->.+<!-- ?/empty_galerie ?-->'isU", "", $template);
    }
  else
    {
      $template = preg_replace("'<!-- ?full_galerie ?-->.+<!-- ?/full_galerie ?-->'isU", "", $template);
    }  
    
  $template = str_replace("%option_delete_dir%", $delete_dir, $template);
  
  //Jumpmenue
  $jumpmenue = get_jumpmenue($_REQUEST['next'], $cfg->folder_upload_images_limit, 10, $galerie->img_sum);
  $template = str_replace("%jumpmenue%", $jumpmenue, $template);  
    
  include("../output.inc.php");
  
  #echo "<pre>"; print_r($_POST); echo "</pre>";
  #echo "<pre>"; print_r($msg); echo "</pre>";
  
?>