<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("include/config.inc.php");
  include("include/functions.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 0;
  $print_footer = 0;
  
  ##################################### Ende Script Einstellungen ###################
  
  //Template Laden
  $template = join("", file("templates/categorie_selection.html"));
  ob_start();
  
  if($print_header)
    {
      include("templates/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("templates/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  $start_categorie = empty($_REQUEST['categorie']) ? 0 : $_REQUEST['categorie'];
  $categories = print_categories(read_categories($start_categorie, "WHERE status = 1"), 1);
  
  #################################### Template Ausgabe ##############################
  
  $template = str_replace("%start_categorie%", $start_categorie, $template);
  $template = str_replace("%categories%", $categories, $template);
  
  include("output.inc.php");
     
?>