<?php

  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  ### Datenbank Einstellungen ###
  
  $cfg->db_host = "localhost";    //Datenbank Host
  $cfg->db_user = "root";         //Datenbank Benutzername
  $cfg->db_pass = "";             //Datenbank Passwort
  $cfg->db_name = "galerie";      //Datenbank Name
  
  ### Datenbank Tabellen ###
  
  # gewnschter Name fr die Tabelle der Kategorien
  $cfg->tb_categories = "galerie_categories";
  
  # gewnschter Name fr die Tabelle der Bilder
  $cfg->tb_images = "galerie_images";
  
  ### Admin Logindaten ###
  
  # Admin Login Name
  $cfg->admin_user = "admin";
  
  # Admin Passwort
  $cfg->admin_pass = "admin";
  
  ### FTP Daten (Freiwillig, ermglicht lschen von Bildern aus dem Upload Ordner)
  
  # FTP Host
  $cfg->ftp_host = "ihre-seite.de";
  
  # FTP Port
  $cfg->ftp_port = 21;
  
  # FTP Login
  $cfg->ftp_user = "login";
  
  # FTP Passwort
  $cfg->ftp_pass = "passwort";
  
  ### Pfadangaben ###
  
  # Absoulter Pfad zum Script (ohne / am Ende)
  $cfg->path = "http://www.ihre-seite.de/photo_galerie";
  
  # Absoulter Serverpafd zum Script (ohne / am Ende)
  $cfg->server_path = "/www/htdocs/web/photo_galerie";
  
  # Absoulter Serverpafd zum Ordner photos|thumbs (ohne / am Ende)
  $cfg->dir_path_photos = "/www/htdocs/web/photo_galerie";
  
  # Virtueller Pfad zum Ordner photos|thumbs (ohne / am Ende)
  $cfg->dir_link_photos = "http://www.ihre-seite.de/photo_galerie";
  
  ### Categorie Search ###
  
  # Max Anzahl der anzuzeigenden Zeilen (0 = alle)
  $cfg->csearch_rows = 3;
  
  # Kategorien pro Zeile
  $cfg->csearch_cols = 5;
  
  # Kategorie Thumb
  $cfg->csearch_categorie_thumb = "images/categorie_thumb.png";
  
  # Unter Kategorie um X Pixel einrcken
  $cfg->subcategorie_indent = 15;
  
  # Name der Home Kategorie
  $cfg->categorie_home_name = "Home";
  
  # Tumbnails pro Zeile
  $cfg->thumbs_columns = 5;
  
  # Thumbnail Zeilen
  $cfg->thumbs_rows = 4;
  
  ### Bilder Upload ###
  
  # Thumb breite
  $cfg->upload_thumb_width = 100;
  
  # Thumb hhe
  $cfg->upload_thumb_height = 80;
  
  # Maximale Bildbreite (Pixel)
  $cfg->upload_maximg_width = 600;
  
  # Maximale Bild Hhe (Pixel)
  $cfg->upload_maximg_height = 400;
  
  
  ### Pflichtangaben beim Upload ###
  
  # muss ein Titel angegeben werden? (1 = Ja, 0 = Nein)
  $cfg->upload_input_title = 0;
  
  # muss eine Beschreibung angegeben werden?
  $cfg->upload_input_description = 0;
  
  ### Jumpmenue Style ###
  
  # Seiten Link, %s = Seitennummer
  $cfg->jumpmenue_link = "%s";
  
  # eine Seite zurck
  $cfg->jumpmenue_arrowl = "<img src=\"%path%/images/arrow_left.png\" border=\"0\" align=\"middle\" />";
  
  # eine Steie weiter
  $cfg->jumpmenue_arrowr = "<img src=\"%path%/images/arrow_right.png\" border=\"0\" align=\"middle\" />";
  
  # ganz an den Anfang
  $cfg->jumpmenue_start = "<img src=\"%path%/images/double_arrow_left.png\" border=\"0\" align=\"middle\" /> Anfang ";
  
  # ganz ans Ende
  $cfg->jumpmenue_end = " Ende <img src=\"%path%/images/double_arrow_right.png\" border=\"0\" align=\"middle\" />";
  
  # Zusammensetzung
  $cfg->jumpmenue_string = "%start% &nbsp;&nbsp;&nbsp; %link% &nbsp;&nbsp;&nbsp; %end%";
  
  # Seiten Links verbinden mit
  $cfg->jumpmenue_glue = "|";
  
  # Anzahl der Bilder in der Slideshow
  $cfg->slide_show_length = 5;
  
  # Kategorien nach X Zeichen abbrechen
  $cfg->chunk_string_length = 15;
  
  # Abbruchzeichen bei zulangem Kategoriename im Kategoriebaum
  $cfg->chunk_string_replace = "&#x2026;";
  
  
  ###################################### Medungen ########################################
  
  $cfg->upload_incorrect_filetype = "Unbekanntes Grafikformat. Es wird nur JPG, PNG & GIF untersttzt.";
  $cfg->upload_fileupload_error = "Es ist ein unbekannter Fehler beim Upload aufgetreten";
  $cfg->upload_no_title = "Bitte geben Sie einen Titel ein";
  $cfg->upload_no_categorie = "Bitte geben Sie eine Kategorie an";
  $cfg->upload_no_description = "Bitte geben Sie eine Beschreibung ein";
  $cfg->upload_incorrect_input = "Ungltige Angaben. Bitte korrigieren Sie diese";
  $cfg->upload_upload_successful = "Upload von Bild %s war erfolgreich";
  
  $cfg->categories_no_name = "Bitte geben sie einen Kategoriename ein";
  $cfg->categories_categorie_renamed = "Kategorie %s wurde in %x umbenannt";
  $cfg->categories_categorie_exists = "Kategorie %s existiert bereits!";
  $cfg->categories_unable_to_delete = "Kategorie %s kann nicht gelscht werden.";
  $cfg->categories_categorie_inserted = "Kategorie %s wurde in %x eingefgt.";
  $cfg->categories_categorie_moved = "Kategorie %s wurde nach %x verschoben";
  $cfg->categories_categorie_deleted = "Kategorie %s wurde gelscht.";
  
  $cfg->ftp_login_failed = "Fehler beim FTP Login. Bitte prfen Sie ihre Zugangsdaten";
  $cfg->ftp_connection_failed = "Konnte Verbindung zum FTP Server nicht aufbauen.";
  
  $cfg->folder_upload_images_moved = "Es wurden %s Bilder nach %x verschoben.";
  $cfg->folder_upload_dir_deleted = "Ordner %s wurde gelscht"; 
     
?>