<?php

  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.1 - Functions
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  # Verbinde mit DB
  mysql_connect($cfg->db_host, $cfg->db_user, $cfg->db_pass);
  mysql_select_db($cfg->db_name);
  
  $msg = null;
  
  
  ################################## Functions #################################
  
  function get_jumpmenue($page, $limit, $max, $count)
    {
      //page = aktuelle Seite
      //limit = anzahl der Datenstze pro Seite
      //max = maximal x Links anzeigen
      //count = anzahl der Datenstze
      
      global $cfg;


      $jumpmenue_link = $cfg->jumpmenue_link;
      $jumpmenue_arrowl = $cfg->jumpmenue_arrowl;
      $jumpmenue_arrowr = $cfg->jumpmenue_arrowr;
      $jumpmenue_string = $cfg->jumpmenue_string;
      $jumpmenue_start = "<a class=\"jmLink\" href=\"%filename%?next=%a%query%\">" . $cfg->jumpmenue_start  . "</a>";
      $jumpmenue_end = "<a class=\"jmLink\" href=\"%filename%?next=%z%query%\">" . $cfg->jumpmenue_end . "</a>";
      $jumpmenue_glue = $cfg->jumpmenue_glue;                          //Seiten mit GLUE verbinden
      
      $filename = $_SERVER['FILENAME'];

      //Query
      foreach ($_GET as $key => $val)
        {
          if ($key != "next")
            {
              $query[] = $key . '=' . $val;
            }
        }
        
      if(!$_GET['categorie'] && $_POST['categorie'])
        {
          $query[] = "categorie=" . $_POST['categorie'];
        }  

      if (is_array($query)) $query = "&" . implode ("&", $query);

      $stop = ceil ($count / $limit);
      $stop = $stop > $max ? $max : $stop;
      $last = ceil ($count / $limit);

      if ($stop > 1)
        {
          $jumpmenue = array ();

          #$page++;

          $h1 = ceil ($max / 2) - 1;

          switch (true)
            {
              case (($page - $h1) < 1):
                $i = 1;
                break;

              case (($page + $h1 + 1) > $last):
                $i = ceil ($count / $limit) - $max + 1;
                if ($i < 1) $i = 1;
                break;

              default:
                $i = $page - $h1;
                break;

            }

          #echo "i:$i d:$d h:$h1 count: $count stop: $stop";
          for ($j = 1; $j <= $stop; $j++)
            {
              $tmp = str_replace ("%s", $i, $jumpmenue_link);

              if ($i == $page)
                {
                  array_push ($jumpmenue,"<span class=\"jmActive\">" . $tmp . "</span>");
                }
              else
                {
                  array_push ($jumpmenue,"<a class=\"jmLink\" href=\"$filename?next=" . $i . $query . "\">" . $tmp . "</a>");
                }
                
              $i++;
            }

          if ($page > 1) array_unshift ($jumpmenue,"<a class=\"jmLink\" href=\"$filename?next=" . round ($page - 1) . $query . "\"><big>" . $jumpmenue_arrowl . "</big></a>");
          if ($page < $last) array_push ($jumpmenue,"<a class=\"jmLink\" href=\"$filename?next=" . round ($page + 1) . $query . "\"><big>" . $jumpmenue_arrowr . "</big></a>");

          $jumpmenue = join ($jumpmenue_glue, $jumpmenue);
          $jumpmenue = str_replace ("%link%", $jumpmenue, $jumpmenue_string);

          #echo " last: $last page: $page";
          //Anfang & Ende
          $jumpmenue = $page > 1 ? str_replace ("%start%", $jumpmenue_start, $jumpmenue) : str_replace ("%start%", "", $jumpmenue);
          $jumpmenue = $page < $last ? str_replace ("%end%", $jumpmenue_end, $jumpmenue) : str_replace ("%end%", "", $jumpmenue);
          
          $jumpmenue = str_replace ("%a", 1, $jumpmenue);
          $jumpmenue = str_replace ("%z", ceil($count / $limit), $jumpmenue);
          $jumpmenue = str_replace ("%page%", $page, $jumpmenue);
          $jumpmenue = str_replace ("%query%", $query, $jumpmenue);
          $jumpmenue = str_replace ("%filename%", $filename, $jumpmenue);

          return $jumpmenue;
        }
    }
  
  function print_categories($catArray, $code = 0)
    {
      global $cfg;

      #echo "<pre>"; print_r($catArray); echo "</pre>";
      
      $codeString[0]['link'] = '<nobr><a class="unselectedCategorie" title="%name%" href="list.php?categorie=%id%">%cat_name%(%counts%)</a></nobr><br />';
      $codeString[0]['subcategorie'] = '<nobr><a class="unselectedCategorie" title="%name%" href="list.php?categorie=%id%">%cat_name%</a></nobr><br />';
      $codeString[1]['link'] = '<nobr><a class="unselectedCategorie" id="cat[%id%]" title="%name%" href="#" onClick="selectCategorie(%id%)">%cat_name%</a></nobr><br />';
      $codeString[1]['subcategorie'] = '<nobr><a class="unselectedCategorie" id="cat[%id%]" title="%name%" href="categorie_selection.php?categorie=%id%">%cat_name%</a></nobr><br />';
      $codeString[2]['link'] = '<nobr><a class="unselectedCategorie" id="cat[%id%]" title="%name%" href="#" onClick="selectCategorie(%id%, \'%name%\')">%cat_name%(%counts%)</a></nobr><br />';
      $codeString[2]['subcategorie'] = '<nobr><a class="unselectedCategorie" id="cat[%id%]" title="%name%" onClick="selectCategorie(%id%, \'%name%\')" href="categorie_selection.php?categorie=%id%">%cat_name%</a></nobr><br />';
      $codeString[3]['link'] = '<nobr><a class="unselectedCategorie" id="cat[%id%]" title="%name%" href="javascript:void(0)" onClick="selectCategorie(%id%)">%cat_name%</a></nobr><br />';
      $codeString[3]['subcategorie'] = '<nobr><a class="unselectedCategorie" id="cat[%id%]" title="%name%" href="select_categorie.php?categorie=%id%&opener=%opener%">%cat_name%</a></nobr><br />';
      
      $array = array();
      
      if (is_array ($catArray))
        {
          foreach ($catArray as $key => $val)
            {
              if (is_array($catArray[$key][1]))
                {
                  $link = str_replace ("%id%", $catArray[$key][0]['id'], $codeString[$code]['subcategorie']);
                  $link = str_replace ("%name%", $catArray[$key][0]['name'], $link);
                  $link = str_replace ("%cat_name%", chunk_str($catArray[$key][0]['name']), $link);
                  array_push($array, '<img src="' . $cfg->path . '/icons/folder.png" border="0" align="middle" style="margin-right: 2px; margin-top: 1px; margin-bottom: 1px" />' . $link);
                  $tmp = open_array($catArray[$key][1], 0, $codeString[$code]);
                  $array = array_merge($array, $tmp);
                }
              else
                {
                  $icon = $catArray[$key]['subcategorie'] == 1 ? 'icons/folder.png' : $catArray[$key]['icon'];

                  if ($catArray[$key]['subcategorie'] == 1)
                    {
                      //Kategorie enthlt unterkategorien
                      $link = $codeString[$code]['subcategorie'];
                    }
                  else
                    {
                      $link = $codeString[$code]['link'];
                      $link = str_replace ("%counts%", $catArray[$key]['counts'], $link);
                    }
                    
                  $link = str_replace ("%id%", $catArray[$key]['id'], $link);
                  $link = str_replace ("%name%", $catArray[$key]['name'], $link);
                  $link = str_replace ("%cat_name%", chunk_str($catArray[$key]['name']), $link);
                  array_push($array, '<img src="' . $cfg->path . "/" . $icon . '" border="0" align="middle" style="margin-right: 2px; margin-top: 1px; margin-bottom: 1px" />' . $link);
                }
            }
        }

      #echo "<pre>"; print_r($catArray); echo "</pre>";

      $array = join ("", $array);
      return $array;
    }

  function print_main_categories($template)
    {
      global $cfg, $_pro;
      
      $array = array();

      $_pro['sql'][] = $sql = "SELECT " . $cfg->tb_categories . ".*
              FROM " . $cfg->tb_categories . "
              WHERE " . $cfg->tb_categories . ".parent = 0
              ORDER BY " . $cfg->tb_categories . ".name ASC";

      if ($result = mysql_query ($sql))
        {

          $i = 0;
          while ($data = mysql_fetch_object ($result))
            {
              $tmp = $template;
              $tmp = str_replace("%id%", $data->id, $tmp);
              $tmp = str_replace("%name%", $data->name, $tmp);
              $tmp = str_replace("%icon%", "icons/directory.png", $tmp);
              
              if ($i == 0)
                {
                  $tmp = "<tr>" . $tmp;
                  $i++;
                }
              elseif ($i >= $cfg->max_table_data)
                {
                  $tmp = $tmp . "</tr>";
                  $i = 0;
                }
              else
                {
                  $i++;
                }
                



              array_push ($array, $tmp);
            }
            
          $array = join("", $array);
        }
      else
        {
          trigger_error(mysql_error() . "<p>$sql</p>");
        }
        
      return stripslashes($array);
    }

  function read_categories($categorie = "", $where = "")
    {
      global $cfg, $msg;
      
      $parent_arr = array();
      
      $parent = $categorie;
        
      while($parent)
        {
          //Lese Ebene ein
          $sql = "SELECT * FROM " . $cfg->tb_categories . " WHERE
                  id = $parent";
                  
          $sql = "SELECT tb1.*, COUNT(tb2.id) AS counts, IF(tb3.id > 0, 1, 0) AS subcategorie 
                  FROM " . $cfg->tb_categories . " AS tb1 
                  LEFT JOIN " . $cfg->tb_images . " AS tb2
                  ON tb1.id = tb2.categorie 
                  LEFT JOIN " . $cfg->tb_categories . " AS tb3 
                  ON tb1.id = tb3.parent
                  WHERE tb1.id = " . $parent . " 
                  GROUP BY tb1.id, tb2.categorie, tb3.parent";
          
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              $data = mysql_fetch_array($result, MYSQL_ASSOC);
              array_push($parent_arr, $data);
              $parent = $data['parent'];
            }
        }
        
      //Home anhngen
      array_push($parent_arr, array("id" => 0,
                                    "parent" => 0,
                                    "name" => $cfg->categorie_home_name,
                                    "status" => "icons/home.png",
                                    "subcategorie" => 1));
                                    
        
        
      //Lese Unterkategorien ein
      $array = array();
      foreach($parent_arr as $key => $val)
        {
          $tmp_arr = "";
          $parent = $val['id'] == "" ? 0 : $val['id'];
          
          $sql = "SELECT tb1.*, COUNT(tb2.id) AS counts, IF(tb3.id > 0, 1, 0) AS subcategorie FROM " . $cfg->tb_categories . " AS tb1 
                  LEFT JOIN " . $cfg->tb_images . " AS tb2
                  ON tb1.id = tb2.categorie 
                  LEFT JOIN " . $cfg->tb_categories . " AS tb3 
                  ON tb1.id = tb3.parent
                  WHERE tb1.parent = '" . $parent . "' 
                  GROUP BY tb1.id, tb2.categorie, tb3.parent";
                  
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              while ($data = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                  $tmp_arr["#" . $data['name']] = $data;
                }
                
              //sortiere Array
              arr_sort($tmp_arr, array("+name"));
            }
            
          $tmp = "";
          
          if(is_array($tmp_arr))
            {
              $tmp["#" . $val['name']][0] = $val;
              $tmp["#" . $val['name']][1] = array_merge($tmp_arr, $array);
              $array = $tmp;
            }
          else
            {
              $tmp["#" . $val['name']] = $val;
              $array = $tmp;
            } 
            
           #echo $val['name'] . "<br />";
           #echo "<pre>"; print_r($array); echo "</pre>";  
        }
          
      
        
      return $array;  
    }
  
  function open_array($array, $i, $codeString)
    {
      global $cfg;

      $tmpArray = array();

      #echo "###<pre>"; print_r($codeString); echo "</pre>###";
      foreach ($array as $key => $val)
        {
          if (is_array($array[$key][1]))
            {
              $i++;
              $icon = $array[$key][0]['subcategorie'] == 1 ? 'icons/folder.png' : $array[$key][0]['icon'];
              $link = str_replace ("%id%", $array[$key][0]['id'], $codeString['subcategorie']);
              $link = str_replace ("%name%", $array[$key][0]['name'], $link);
              $link = str_replace ("%cat_name%", chunk_str($array[$key][0]['name']), $link);
              array_push($tmpArray, '<img src="images/empty.gif" border="0" width="' . $i * $cfg->subcategorie_indent . 'px" height="5px" align="middle" /><img src="' . $cfg->path . "/" . $icon . '" border="0" align="middle" style="margin-right: 2px" />' . $link);
              $tmp = open_array($array[$key][1], $i, $codeString);
              $i--;
              $tmpArray = array_merge($tmpArray, $tmp);
            }
          else
            {
              $i++;
              $icon = $array[$key]['subcategorie'] == 1 ? 'icons/folder.png' : $array[$key]['icon'];

              if ($array[$key]['subcategorie'] == 1)
                {
                  //Kategorie enthlt unterkategorien
                  $link = $codeString['subcategorie'];
                }
              else
                {
                  $link = $codeString['link'];
                  $link = str_replace ("%counts%", $array[$key]['counts'], $link);
                }

              $link = str_replace ("%id%", $array[$key]['id'], $link);
              $link = str_replace ("%name%", $array[$key]['name'], $link);
              $link = str_replace ("%cat_name%", chunk_str($array[$key]['name']), $link);
              array_push($tmpArray, '<img src="images/empty.gif" border="0" width="' . $i * $cfg->subcategorie_indent . 'px" height="5px" align="middle" /><img src="' . $cfg->path . "/" . $icon . '" border="0" align="middle" style="margin-right: 2px" />' . $link);
              $i--;
            }
        }

      return $tmpArray;
    }
    
  function categorie_path($categorie, $mode = 0)
    {
      global $cfg;

      //Ermittle Aktuelle Kategorie mit Pfad.
      $curcat = empty ($categorie) ? "0" : $categorie;
      
      $array = array();


      do
        {
          $sql = "SELECT * FROM " . $cfg->tb_categories . " WHERE id = $curcat";
          if ($result = mysql_query ($sql))
            {
              $data = mysql_fetch_object ($result);
              if(mysql_num_rows($result) > 0)
                {
                  if (count($array) == 0)
                    {
                      array_unshift ($array, $data->name);
                    }
                  else
                    {
                      if($mode == 1)
                        {
                          array_unshift ($array, $data->name);
                        }
                      else
                        {
                          array_unshift ($array, '<a class="link4" href="list.php?categorie=' . $data->id . '">' . $data->name . '</a>');
                        }  
                    }
                }
            }
          else
            {
              error(__FILE__, __LINE__, mysql_error() . "<p>$sql</p>");
            }
            
          $curcat = $data->parent;
        }
      while (!empty($data->parent));
      
      #echo "<pre>"; print_r($array); echo "</pre>";
      
      //Home Categorie Voranstellen
      if (count($array) == 0)
        {
          array_unshift ($array, $cfg->categorie_home_name);
        }
      else
        {
          if($mode == 1)
            {
              array_unshift ($array, $cfg->categorie_home_name);
            }
          else
            {
              array_unshift ($array, '<a class="link4" href="list.php?categorie=0">' . $cfg->categorie_home_name . '</a>');
            }
            
        }
      
      
      if($mode == 1)
        {
          $categorie_path = join ('/', $array);
        }
      else
        {
          $categorie_path = join (' <img src="' . $cfg->path . '/images/arrow.png" border="0" align="middle" /> ', $array);
        }
      
      return $categorie_path;
      
    } //end func categorie_path

  function get_parent ($categorie)
    {
      global $cfg;
      
      //Lese Elternelement ein
      $sql = "SELECT parent FROM " . $cfg->tb_categories . " WHERE id = $categorie LIMIT 1";
      if ($result = mysql_query ($sql))
        {
          $data = mysql_fetch_object ($result);
        }
      else
        {
          trigger_error(mysql_error() . "<p>$sql</p>");
        }
        
      return $data->parent;
    }
    
  function chunk_str($str, $length = "", $replace = "")
    {
      global $cfg;
      
      $length = empty($length) ? $cfg->chunk_string_length : $length;
      $replace = empty($replace) ? $cfg->chunk_string_replace : $replace;
      
      if(strlen($str) > $length)
        {
          $str = substr_replace($str, $replace, $length);
        }
        
      return $str;  
    }  
    
    
  function image_scall($width, $height, $scallwidth, $scallheight)
    {
      //Funktion berechnet Bildskalierung
      //Erwartet Bildbreite, Bildhhe, Skallierbreite, Skallierhhe
      #echo "$width, $height, $scallwidth, $scallheight +++ ";
    
      if ($width > $scallwidth || $height > $scallheight)
        {
          if ($width - $scallwidth > $height - $scallheight)
            {
              //In der Breite skalieren
              $div = $scallwidth / $width;
              $height = round($height * $div);
              $width = $scallwidth;
            }
          else  
            {
              //In der Hhe skalieren
              $div = $scallheight / $height;
              $width = round($width * $div);
              $height = $scallheight;
            }  
        }
        
      #echo " +++ $width, $height #### ";
      
      return array($width, $height);
      
    } //end func image_scall  
    
  function make_image($imgname, $imgsrc, $width, $height, $size)
    {
      //Erzeuge Bild
      $img = imagecreatetruecolor($width, $height);
      
      switch($size[2])
        {
          case 1:
            $img2 = imagecreatefromgif($imgsrc);
            break;
            
          case 2:
            $img2 = imagecreatefromjpeg($imgsrc);
            break;
            
          case 3:
            $img2 = imagecreatefrompng($imgsrc);
            break;
        }
        
      imagecopyresampled($img, $img2, 0, 0, 0, 0, $width, $height, $size[0], $size[1]);
      
      switch($size[2])
        {
          case 1:
            imagegif($img, $imgname);
            break;
            
          case 2:
            imagejpeg($img, $imgname, 100);
            break;
            
          case 3:
            imagepng($img, $imgname);
            break;
        }
        
      imagedestroy($img);
      imagedestroy($img2);  
    }
    
  function arr_sort(&$array, $args) 
    {
      if(is_array($array) && count($array) > 0)
        { 
          $args = array_reverse($args); 
          foreach($args as $arg) 
            { 
              $temp_array = $array; 
              $array = array(); 
              $order_key = substr($arg, 1, strlen($arg)); 
              foreach($temp_array as $index => $nirvana)
                {
                  $sort_array[$index] = $temp_array[$index][$order_key]; 
                }
                
                ($arg[0] == "+") ? (natcasesort($sort_array)) : (arsort($sort_array)); 
                foreach($sort_array as $index => $dummy) 
                  {
                    $array[$index] = $temp_array[$index]; 
                  }
              }
          } 
      } 
        
  function user_filesize($bytes)
    {
      $i = 0;
      while ($bytes > 1024)
        {
          $bytes /= 1024;
          $i++;
        }
        
      $array = array("Bytes", "kB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB");  
        
      $bytes = round($bytes, 1);
      $bytes = $bytes .= " " . $array[$i];
      return $bytes;  
    }
    
  function delete_img($img)
    {
      global $msg, $cfg;
      
      if(!is_array($img))
        {
          $img = array($img);
        }
      
      //Lsche altes Bild
      if($cfg->ftp_user)
        {
          $ftp_conn = ftp_connect($cfg->ftp_host, $cfg->ftp_port);
          if($ftp_conn)
            {
              if($ftp = ftp_login($ftp_conn, $cfg->ftp_user, $cfg->ftp_pass))
                {
                  foreach($img as $img_file)
                    {
                      $url = parse_url($cfg->dir_link_photos);
                      if(ftp_delete($ftp_conn, $url['path'] . "/upload/" . $img_file))
                        {
                          $del_counter++;
                        }
                    }
                }
              else
                {
                  $error = 1;
                  $msg->error = $cfg->ftp_login_failed;
                }
                  
              ftp_close($ftp_conn);
            }
          else
            {
              $error = 1;
              $msg->error = $cfg->ftp_connection_failed;
            }  
        }
          
      return $del_counter;
    }
    
  function delete_dir($dir)
    {
      global $msg, $cfg;
      
      if(!is_array($dir))
        {
          $dir = array($dir);
        }
        
      //Lsche Ordner
      if($cfg->ftp_user)
        {
          $ftp_conn = ftp_connect($cfg->ftp_host, $cfg->ftp_port);
          if($ftp_conn)
            {
              if($ftp = ftp_login($ftp_conn, $cfg->ftp_user, $cfg->ftp_pass))
                {
                  foreach($dir as $dir_name)
                    {
                      //Ordner leeren
                      $url = parse_url($cfg->dir_link_photos);
                      
                      $delete_counter = ftp_delete_dir($ftp_conn, $url['path'] . "/upload/" . $dir_name);
                    }
                }
              else
                {
                  $error = 1;
                  $msg->error = $cfg->ftp_login_failed;
                }
                  
              ftp_close($ftp_conn);
            }
          else
            {
              $error = 1;
              $msg->error = $cfg->ftp_connection_failed;
            }  
        }
          
      return $del_counter;
    }
    
  function ftp_delete_dir($ftp_conn, $dir)
    {
      if(preg_match("'\.{1,2}$'i", $dir))
        {
          trigger_error("Unable to delete '$dir'", E_USER_ERROR);
        }
      
      $file_list = ftp_nlist($ftp_conn, $dir);
      $del_counter = 0;
                      
      for($i = 0; $i < count($file_list); $i++)
        {
          if(!preg_match("'\.{1,2}$'i", $file_list[$i]))
            {
              #echo "FILE: " . $file_list[$i] . "<br />";
              if(!@ftp_rmdir($ftp_conn, $file_list[$i]) && !@ftp_delete($ftp_conn, $file_list[$i]))
                {
                  #echo "->" . $file_list[$i] . "<br />";
                  $del_counter += ftp_delete_dir($ftp_conn, $file_list[$i]);
                }
              else
                {
                  #echo "DELETE: " . $file_list[$i] . "<br />";
                  $del_counter++;
                }  
            }
        }
        
      if(@ftp_rmdir($ftp_conn, $dir))
        {
          $del_counter++;
        }
        
      return $del_counter;  
    }  
    
  function get_subcategories($categorie)
    {
      global $cfg;
      
      $array = array();
      array_push($array, $categorie);
      
      //Lese Unterkategorien von $categorie ein
      $sql = "SELECT id, name FROM " . $cfg->tb_categories . " WHERE parent = $categorie";
      $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
      if($result)
        {
          while($data = mysql_fetch_object($result))
            {
              $tmp = get_subcategories($data->id);
              if(is_array($tmp))
                {
                  $array = array_merge($array, $tmp);
                }
              
            }
        }
        
      return $array;  
    }
    
  function get_categorie_name($categorie)
    {
      //Lese Kategorie Name ein
      global $cfg;
      
      if($categorie > 0)
        {
          $sql = "SELECT name FROM " . $cfg->tb_categories . " WHERE id = '$categorie' LIMIT 1";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              $name = mysql_result($result, 0);
            }
        }
      else
        {
          $name = $cfg->categorie_home_name;
        }  
        
      return $name;  
    }
    
  function array_key_reset(&$array)
    {
      //Funktion vergibt den Array Key neu
      $new_array = array();
      
      foreach($array as $val)
        {
          array_push($new_array, $val);
        }
        
      $array = $new_array;
    }

?>