<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("include/config.inc.php");
  include("include/functions.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  $cfg->thumbs_columns = 3;
  
  //Template Laden
  $template = join("", file("templates/index.html"));
  ob_start();
  
  if($print_header)
    {
      include("templates/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("templates/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  class galerie
    {
      var $data_arr = array();
      var $img_sum;
      
      function get_data()
        {
          //Lese Bilder aus DB ein
          global $cfg;
          
          $order = "id ASC";
          $limit = "6";
          
          $sql = "SELECT * FROM " . $cfg->tb_images . " WHERE startpage = 1 AND status = 1 ORDER BY " . $order . " LIMIT " . $limit;
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              while ($data = mysql_fetch_object($result))
                {
                  array_push($this->data_arr, $data);
                }
            }
        }
        
      function list_galerie()
        {
          global $cfg, $template;
          
          preg_match("'<!-- ?table_col ?-->.+<!-- ?/table_col ?-->'is", $template, $preg);
          $tablecol = $preg[0];
          
          preg_match("'<!-- ?table_row ?-->.+<!-- ?/table_row ?-->'is", $template, $preg);
          $tablerow = $preg[0];
          
          $tabledata = array();
          $tableoutput = array();
          
          $this->get_data();
          
          $col = 1;
          
          for ($i = 0; $i < count($this->data_arr); $i++)
            {
              $data = $this->data_arr[$i];
              
              $tmp = $tablecol;
              $tmp = str_replace("%categorie%", $data->categorie, $tmp);
              $tmp = str_replace("%thumb%", $cfg->dir_link_photos . "/" . $data->thumb, $tmp);
              $tmp = str_replace("%title%", $data->title, $tmp);
              $tmp = str_replace("%description%", $data->description, $tmp);
              $tmp = str_replace("%id%", $data->id, $tmp);
              $tmp = str_replace("%width%", $cfg->upload_thumb_width, $tmp);
              $tmp = str_replace("%height%", $cfg->upload_thumb_height, $tmp);
              
              array_push($tabledata, $tmp);
              
              if(++$col > $cfg->thumbs_columns)
                {
                  //Setze Cols zusammen
                  $tabledata = join("", $tabledata);
                  array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));
                  $tabledata = array();
                  $col = 1;
                }
            }
            
          //Setze restliche Cols zusammen
          $tabledata = join("", $tabledata);
          array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));  
            
          //Rows in TPL einfgen
          $tableoutput = join("", $tableoutput);
          $template = str_replace($tablerow, $tableoutput, $template);
        }  
    }
    
  $galerie = new galerie;
  $listing = $galerie->list_galerie();
  
  #################################### Template Ausgabe ##############################
  
  include("output.inc.php");
     
?>