<?php
     
  /* +-----------------------------------------------------------------------+
     | Photo Galerie 1.0
     |
     | Copyright (c) Firma www-Gestaltung - Webentwicklung
     | Developed by Andi Heinkelein, 16-Jan-2006
     | http://www-gestaltung.de
     +-----------------------------------------------------------------------+ */
     
  include("include/config.inc.php");
  include("include/functions.inc.php");
  
  #################################### Script Einstellungen #########################
  
  #Header/Footer einbinden? (0 = nein, 1 = ja)
  $print_header = 1;
  $print_footer = 1;
  
  $start_categorie = empty($_REQUEST['categorie']) ? 0 : $_REQUEST['categorie'];
  
  ##################################### Ende Script Einstellungen ###################
  
  $_REQUEST['next'] = $_REQUEST['next'] or $_REQUEST['next'] = 1;
  
  //Template Laden
  $template = join("", file("templates/list.html"));
  ob_start();
  
  if($print_header)
    {
      include("templates/header.html");
    }
    
  echo $template;
  
  if($print_footer)
    {
      include("templates/footer.html");
    }
    
  $template = ob_get_contents();
  ob_end_clean();
  
  #################################### Script Functions ##############################
  
  class galerie
    {
      var $data_arr = array();
      var $img_sum;
      
      function get_categories($categorie)
        {
          global $cfg;
          
          $array = array();
          
          //Lese Kategorien ein
          $sql = "SELECT * FROM " . $cfg->tb_categories . " WHERE parent = $categorie";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              while($data = mysql_fetch_array($result, MYSQL_ASSOC))
                {
                  array_push($array, $data);
                }
            }
            
          //Sortiere Array
          if(count($array) > 0)
            {
              arr_sort($array, array("+name"));
            }
          
          return $array;
        }
      
      function get_data()
        {
          //Lese Bilder aus DB ein
          global $cfg;
          
          $next = empty($_REQUEST['next']) ? 0 : $_REQUEST['next'] - 1;
          $limit = $cfg->thumbs_columns * $cfg->thumbs_rows;
          $start = $next * $limit;
          
          $order = "pos ASC";
          $limit = "$start, $limit";
          
          $sql = "SELECT * FROM " . $cfg->tb_images . " WHERE categorie = '" . $_REQUEST['categorie'] . "' AND status = 1 ORDER BY " . $order . " LIMIT " . $limit;
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          if($result)
            {
              while ($data = mysql_fetch_object($result))
                {
                  array_push($this->data_arr, $data);
                }
            }
            
          //Zhle Datenstze
          $sql = "SELECT COUNT(*) FROM " . $cfg->tb_images . " WHERE categorie = '" . $_REQUEST['categorie'] . "' AND status = 1";
          $result = mysql_query($sql) or trigger_error(mysql_error() . "<p>$sql</p>");
          $this->img_sum = mysql_result($result, 0);
        }
        
      function list_categories()
        {
          global $cfg, $template;
          
          preg_match("'<!-- ?categorie_col ?-->.+<!-- ?/categorie_col ?-->'is", $template, $preg);
          $tablecol = $preg[0];
          
          preg_match("'<!-- ?categorie_row ?-->.+<!-- ?/categorie_row ?-->'is", $template, $preg);
          $tablerow = $preg[0];
          
          $tabledata = array();
          $tableoutput = array();
          
          $categorie = empty($_REQUEST['categorie']) ? 0 : $_REQUEST['categorie'];
          $array = $this->get_categories($categorie);
          
          $col = 1;
          
          foreach ($array as $data)
            {
              settype($data, "object");
              
              $tmp = $tablecol;
              $tmp = str_replace("%categorie%", $data->categorie, $tmp);
              $tmp = str_replace("%id%", $data->id, $tmp);
              $tmp = str_replace("%name%", $data->name, $tmp);
              
              array_push($tabledata, $tmp);
              
              if(++$col > $cfg->csearch_cols)
                {
                  //Setze Cols zusammen
                  $tabledata = join("", $tabledata);
                  array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));
                  $tabledata = array();
                  $col = 1;
                }
            }
            
          //Setze restliche Cols zusammen
          $tabledata = join("", $tabledata);
          array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));  
            
          //Rows in TPL einfgen
          $tableoutput = join("", $tableoutput);
          $template = str_replace($tablerow, $tableoutput, $template);
        }  
        
      function list_galerie()
        {
          global $cfg, $template;
          
          preg_match("'<!-- ?table_col ?-->.+<!-- ?/table_col ?-->'is", $template, $preg);
          $tablecol = $preg[0];
          
          preg_match("'<!-- ?table_row ?-->.+<!-- ?/table_row ?-->'is", $template, $preg);
          $tablerow = $preg[0];
          
          $tabledata = array();
          $tableoutput = array();
          
          $this->get_data();
          
          $col = 1;
          
          for ($i = 0; $i < count($this->data_arr); $i++)
            {
              $data = $this->data_arr[$i];
              
              $tmp = $tablecol;
              $tmp = str_replace("%categorie%", $data->categorie, $tmp);
              $tmp = str_replace("%thumb%", $cfg->dir_link_photos . "/" . $data->thumb, $tmp);
              $tmp = str_replace("%title%", $data->title, $tmp);
              $tmp = str_replace("%description%", $data->description, $tmp);
              $tmp = str_replace("%id%", $data->id, $tmp);
              $tmp = str_replace("%width%", $cfg->upload_thumb_width, $tmp);
              $tmp = str_replace("%height%", $cfg->upload_thumb_height, $tmp);
              
              array_push($tabledata, $tmp);
              
              if(++$col > $cfg->thumbs_columns)
                {
                  //Setze Cols zusammen
                  $tabledata = join("", $tabledata);
                  array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));
                  $tabledata = array();
                  $col = 1;
                }
            }
            
          //Setze restliche Cols zusammen
          $tabledata = join("", $tabledata);
          array_push($tableoutput, str_replace($tablecol, $tabledata, $tablerow));  
            
          //Rows in TPL einfgen
          $tableoutput = join("", $tableoutput);
          $template = str_replace($tablerow, $tableoutput, $template);
        }  
    }
    
  $galerie = new galerie;
  $listing = $galerie->list_galerie();
  $galerie->list_categories();
  
  #################################### Template Ausgabe ##############################
  
  $start_categorie = empty($_REQUEST['categorie']) ? 0 : $_REQUEST['categorie'];

  $categories = print_categories(read_categories($start_categorie), 0);
  $template = str_replace("%categories%", $categories, $template);
  #$template = str_replace("%listing%", $listing, $template);
  $template = str_replace("%categorie_path%", categorie_path($start_categorie), $template);
  $template = str_replace("%next%", $_REQUEST['next'], $template);
  
  if($galerie->img_sum > 0)
    {
      $template = preg_replace("'<!-- ?empty_categorie ?-->.+<!-- ?/empty_categorie ?-->'isU", "", $template);
    }
    
  //Jumpmenue
  $jumpmenue = get_jumpmenue($_REQUEST['next'], $cfg->thumbs_columns * $cfg->thumbs_rows, 10, $galerie->img_sum);
  $template = str_replace("%jumpmenue%", $jumpmenue, $template);
  
  include("output.inc.php");
  
  #echo "<pre>"; print_r($galerie->data_arr); echo "</pre>";
     
?>